-- Main.lua
-- Originally written by Rod, extended by Habna

-- HugeBag Known bugs:
-- Unload command is not working ( Known API Issues ) ( Working but with the Utility plugin )
-- Reload command is not working ( Known API Issues ) ( Working but with the Utility plugin )
-- When right clicking on a tool the icon is not swaping properly ( Known API Issues  )
-- Replace HugeBag when the display size changed. (It's currently replacing himself when any bags action event is fired)

-- HugeBag future functions:
-- Sorting option

-- HugeBag change log:
-- 1.1.6 (2001/05/25) : Partial bug fix: HugeBag Widget will replace himself (at any bag action event, not when the display size has changed) at the right place if the window size has changed.
--					  : Bug fix: HugeBag Widget will resize to fit your 3 or 5 bags.
--					  : Work around: The 'Unload', 'Load' & 'Reload' commands are now available only if user load the 'HugeBag - Utility' plugin.

-- 1.1.5 (2011/05/24) : Added the option to switch between window and widget mode, default mode is widget.

-- 1.0.5 (2011/05/21) : Changed the content menu into a window.
--					  : Changed the layout of the "Shell Command" window.

-- 1.0.4 (2011/05/20) : Added the option to show free or used slots informations in the title.
--					  : Added the 'About' window.
--					  : Added the 'Shell Command' window.

-- 1.0.3 (2011/05/19) : Bug fix: HugeBag is independant of any plugins manager. User can load/unload HugeBag manually with shell command.
--					  : Added the option to lock/unlock Hugebag size.
--					  : Added the option to lock/unlock Hugebag position.
--					  : Bug fix: HugeBag will not go beyond the screen border in window-mode.
--					  : Added the option for the settings to uptaded himself if a different version is detected, old user settings will remains unchanged.
--					  : Added the option to only reset location and size settings to default.
--					  : Added the option to resize HugeBag from both bottom corner.
--					  : Watermark label was removed, it will be in the 'about' window when it will be available.
--					  : Alot of functions are now in a seperate file. To clean the main file a bit.
--					  : All settings functions are now in a seperate file. To clean the main file a bit. 

-- 1.0.2 (2011/05/16) : Bug fix: Was unable to resize HugeBag when the 'reset' was launch.
--					  : Added a Watermark label of the authors Rod, Almagnus1 & Habna (me).
--					  : Added the option to toggle the hide HugeBag event when 'esc' key is press.
--					  : Independant of Turbine plugins.

-- 1.0.1 (2011/05/15) : Added a context menu with right mouse click on the upper left corner.

-- 1.0.0 (2011/05/15) : Initial release.

import "HabnaPlugins.HugeBag";
import "HabnaPlugins.HugeBag.frmSettings"; -- LUA settings file

LoadSettings();

if ( Widget ) then
	import "HabnaPlugins.HugeBag.frmMainWidget";
else
	import "HabnaPlugins.HugeBag.frmMain";
end

frmMain = frmMain();

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );

HugeBagCommand = Turbine.ShellCommand();

function HugeBagCommand:Execute( command, arguments )
	if ( Widget ) then
		if ( arguments == "show" ) then
			ShowHugeBag()
		elseif ( arguments == "hide" ) then
			HideHugeBag()
		elseif ( arguments == "version" ) then
			VersionInfo()
		elseif ( arguments == "author" or arguments == "authors" ) then
			AuthorsInfo()
		elseif ( arguments == "about" ) then
			ShowAbout()
		elseif ( arguments == "resetall" ) then
			ResetSettings()
		elseif ( arguments == "help" or arguments == "?") then
			HelpInfo()
		elseif ( arguments == "slotsinfo" ) then
			SlotsInfo()
		--elseif ( arguments == "unload" ) then
			--UnloadHugeBag()
		--elseif ( arguments == "reload" ) then
			--ReloadHugeBag()
		--elseif ( arguments == "sort" ) then
			--SortHugeBag()
		elseif ( arguments == "toggleshow" ) then
			ToggleShow()
		elseif ( arguments == "togglewesc" ) then
			ToggleWEsc()
		elseif ( arguments == "togglewidget" ) then
			ToggleWidgetMode()
		else
			write( "HugeBag: Command not supported" );
		end
	else
		if ( arguments == "show" ) then
			ShowHugeBag()
		elseif ( arguments == "hide" ) then
			HideHugeBag()
		elseif ( arguments == "version" ) then
			VersionInfo()
		elseif ( arguments == "author" or arguments == "authors" ) then
			AuthorsInfo()
		elseif ( arguments == "about" ) then
			ShowAbout()
		elseif ( arguments == "resetall" ) then
			ResetSettings()
		elseif ( arguments == "resetls" ) then
			ResetLSSettings()
		elseif ( arguments == "help" or arguments == "?") then
			HelpInfo()
		elseif ( arguments == "slotsinfo" ) then
			SlotsInfo()
		--elseif ( arguments == "unload" ) then
			--UnloadHugeBag()
		--elseif ( arguments == "reload" ) then
			--ReloadHugeBag()
		--elseif ( arguments == "sort" ) then
			--SortHugeBag()
		elseif ( arguments == "locksize" ) then
			LockHugeBagSize()
		elseif ( arguments == "lockpos" or arguments == "lockposition") then
			LockHugeBagPosition()
		elseif ( arguments == "toggleshow" ) then
			ToggleShow()
		elseif ( arguments == "toggleslots" ) then
			ToggleSlotsInfo()
		elseif ( arguments == "toggleused" ) then
			ToggleFreeUsed()
		elseif ( arguments == "togglewesc" ) then
			ToggleWEsc()
		elseif ( arguments == "togglewidget" ) then
			ToggleWidgetMode()
		elseif ( arguments == "curopt" ) then
			ShowCurrentSettings()
		else
			write( "HugeBag: Command not supported" );
		end
	end
end
Turbine.Shell.AddCommand( "HugeBag", HugeBagCommand );

if ( StartVisible ) then
	write( "HugeBag v" .. Version .. " by Habna: I'm loaded" );
else
	Turbine.Shell.WriteLine( "HugeBag v" .. Version .. " by Habna: I'm loaded BUT NOT visible" );
end

if ( ShowSlotsInfo ) then
	SlotsInfo()
end

Turbine.Plugin.Unload = function( self, sender, args )
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );
end