-- HugeBagWindow.lua
-- Originally TheOneBagWindow.lua written by Rod, extended by Habna

--v IMPORT SECTION v--
--import "Turbine";
import "Turbine.Gameplay";
--import "Turbine.UI";
--import "Turbine.UI.Lotro";
import "HabnaPlugins.HugeBag.functions"; -- LUA functions file

--^ IMPORT SECTION ^--
--v GLOBAL VARIABLE SECTION v--
WInitXPos, WInitYPos = 30, 30; --> ** Initial X & Y position of the first Item in the HugeBag **
WWinWidth, WWinHeight = 450, 289; --> ** HugeBag initial size **
--screenWidth, screenHeight = Turbine.UI.Display.GetSize()
winRate = 30;

frmMain = class( Turbine.UI.Lotro.Window );
--frmMain = class( Turbine.UI.Lotro.GoldWindow ); --Gold Window
--^ GLOBAL VARIABLE SECTION ^--

function frmMain:Constructor()
	--v SETTINGS SECTION v--
	Turbine.UI.Lotro.Window.Constructor( self );
	--Turbine.UI.Lotro.GoldWindow.Constructor( self ); --Gold Window
	
	-- **v Get player gameplay v**
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.backpack = Turbine.Gameplay.LocalPlayer.GetInstance():GetBackpack();
	else
		self.backpack = Turbine.Gameplay.LocalPlayer():GetBackpack();
	end
	-- **^

	backpackSize = self.backpack:GetSize();
	
	--**v Set some settings of HugeBag window v**
	self:SetVisible( true );
	self:SetBackColor( Turbine.UI.Color() );
	if ( StartVisible ) then
		windowOpen = true;
		self:SetLeft( screenWidth - ( winRate * 15 ) + 2 );
	else
		windowOpen = false;
		self:SetLeft( screenWidth - 28 );
	end
	self:SetOpacity( DefaultOpacity );
	self:SetAllowDrop( true );
	self:SetWantsKeyEvents( true );
	--self:SetWantsUpdates( true );
	self:SetZOrder( 5 );
	--**^
	-- **v Set Top and size of window v** --
	if backpackSize == 45 then
		self:SetTop( screenHeight - WWinHeight + 69 - 75 );
		self:SetSize( WWinWidth, WWinHeight - 69 );
	else
		self:SetTop( screenHeight - WWinHeight - 75 );
		self:SetSize( WWinWidth, WWinHeight );
	end
	-- **^
	-- **v Set control bar v**
	topLeftCorner=Turbine.UI.Control();
	topLeftCorner:SetParent( self );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 30, 20 );
	--topLeftCorner:SetBackColor( Turbine.UI.Color( .6, 0, 0, 0 ) );
	
	leftBar=Turbine.UI.Control();
	leftBar:SetParent( self );
	leftBar:SetPosition( 0, 20 );
	leftBar:SetSize( 30, self:GetHeight() - 20 );
	--leftBar:SetBackColor( Turbine.UI.Color( .6, 0, 0, 0 ) );
	
	allBar=Turbine.UI.Control();
	allBar:SetParent( self );
	allBar:SetPosition( 30, 0 );
	allBar:SetSize( self:GetWidth()-31, self:GetHeight() );
	--allBar:SetBackColor( Turbine.UI.Color( .6, 0, 0, 0 ) );
	-- **^
	-- **v Set Image on control bar v** --
	tt=Turbine.UI.Control();
	tt:SetParent( topLeftCorner );
	tt:SetPosition( 0, 0);
	tt:SetSize( 30, 20);
	tt:SetBackground( "HabnaPlugins/HugeBag/Resources/tab_top.tga" );
	tt:SetMouseVisible( false );
	
	tm=Turbine.UI.Control();
	tm:SetParent( leftBar );
	tm:SetPosition( 0, 0);
	tm:SetSize( 30, leftBar:GetHeight() - 20 );
	tm:SetBackground( "HabnaPlugins/HugeBag/Resources/tab_mid.tga" );
	tm:SetMouseVisible( false );
	
	tb=Turbine.UI.Control();
	tb:SetParent( leftBar );
	tb:SetPosition( 0, leftBar:GetHeight() - 20 );
	tb:SetSize( 30, 20 );
	tb:SetBackground( "HabnaPlugins/HugeBag/Resources/tab_bottom.tga" );
	tb:SetMouseVisible( false );
	
	tlabel=Turbine.UI.Control();
	tlabel:SetParent( leftBar );
	tlabel:SetZOrder( 10 );
	tlabel:SetPosition( 9, ( self:GetHeight() / 2 ) - 62 );
	tlabel:SetSize( 14, 88 );
	tlabel:SetBackground( "HabnaPlugins/HugeBag/Resources/label.tga" );
	tlabel:SetMouseVisible( false );
	
	top=Turbine.UI.Control();
	top:SetParent( allBar );
	top:SetPosition( 0, 0 );
	top:SetSize( allBar:GetWidth() - 30, 30 );
	top:SetBackground( "HabnaPlugins/HugeBag/Resources/top.tga" );
	top:SetMouseVisible( false );
	
	bot=Turbine.UI.Control();
	bot:SetParent( allBar );
	bot:SetPosition( 0, allBar:GetHeight() - 10 );
	bot:SetSize( allBar:GetWidth() - 30, 10 );
	bot:SetBackground( "HabnaPlugins/HugeBag/Resources/bot.tga" );
	bot:SetMouseVisible( false );
	
	right=Turbine.UI.Control();
	right:SetParent( allBar );
	right:SetPosition( allBar:GetWidth() - 30, 0 );
	right:SetSize( 30, self:GetHeight() );
	right:SetBackground( "HabnaPlugins/HugeBag/Resources/right.tga" );
	right:SetMouseVisible( false );
	
	rlabel=Turbine.UI.Control();
	rlabel:SetParent( self );
	rlabel:SetZOrder( 10 );
	rlabel:SetPosition( self:GetWidth() - 22, ( self:GetHeight() / 2 ) - 42 );
	rlabel:SetSize( 14, 88 );
	rlabel:SetBackground( "HabnaPlugins/HugeBag/Resources/label.tga" );
	rlabel:SetMouseVisible( false );
	-- **^
	-- **v Set some settings of the itemlistbox v**
	itemListBox = Turbine.UI.ListBox();
	itemListBox:SetParent( self );
	itemListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	itemListBox:SetPosition( WInitXPos, WInitYPos );
	itemListBox:SetBackColor( Turbine.UI.Color( 0, 0, 0, 0 ) );
	itemListBox:SetMaxItemsPerLine( 11 );
	-- **^
	-- **v Set size of the listbox v** --
	if backpackSize == 45 then
		itemListBox:SetSize( 389, 180 ); -- to show 45 slots
	else
		itemListBox:SetSize( 389, 249 ); -- to show 75 slots
	end
	-- **^
	-- **v Set context menu items v**
	self.menu = Turbine.UI.ContextMenu()
	self.menu.items = self.menu:GetItems()

	local option_line = Turbine.UI.MenuItem("-----------------------------------------------------------------------", false, "line")
	--[[
	local option_reload = Turbine.UI.MenuItem("Reload HugeBag plugin instance", true, "reload")
	option_reload.Click = ReloadHugeBag

	local option_unload = Turbine.UI.MenuItem("Unload HugeBag plugin from memory", true, "unload")
	option_unload.Click = UnloadHugeBag
	]]
	local option_help = Turbine.UI.MenuItem("Show HugeBag Widget shell commands", true, "help")
	option_help.Click = HelpInfo

	local option_about = Turbine.UI.MenuItem("About HugeBag", true, "about")
	option_about.Click = ShowAbout

	local option_resetall = Turbine.UI.MenuItem("Reset all settings to default", true, "resetall")
	option_resetall.Click = ResetSettings

	local option_slotsinfo = Turbine.UI.MenuItem("Show free, used and max slots in shell", true, "slotsinfo")
	option_slotsinfo.Click = SlotsInfo

	local option_togglewesc = Turbine.UI.MenuItem("Toggle hide event when the 'esc' key is press", true, "togglewesc")
	option_togglewesc.Click = ToggleWEsc

	local option_togglewidget = Turbine.UI.MenuItem("Toggle from widget and window mode", true, "togglewidget")
	option_togglewidget.Click = ToggleWidgetMode

	local option_toggleshow = Turbine.UI.MenuItem("Toggle the startup visibility of HugeBag", true, "toggleshow")
	option_toggleshow.Click = ToggleShow

	self.menu.items:Add(option_toggleshow)
	self.menu.items:Add(option_togglewesc)
	self.menu.items:Add(option_togglewidget)
	self.menu.items:Add(option_line) ------
	self.menu.items:Add(option_slotsinfo)
	self.menu.items:Add(option_help)
	self.menu.items:Add(option_line) ------
	self.menu.items:Add(option_resetall)
	self.menu.items:Add(option_line) ------
	--self.menu.items:Add(option_reload)
	--self.menu.items:Add(option_unload)
	self.menu.items:Add(option_about)
	-- **^
	self:SetBackPack(); --> ** Set the backpack **
	--^ SETTINGS SECTION ^--

	--v EVENT HANDLERS SECTION v--
	--**v control bar event handlers v**
	
	leftBar.MouseEnter=function(sender,args)
		tt:SetBackground("HabnaPlugins/HugeBag/Resources/tab_top_over.tga");
		tb:SetBackground("HabnaPlugins/HugeBag/Resources/tab_bottom_over.tga");
		tm:SetBackground("HabnaPlugins/HugeBag/Resources/tab_mid_over.tga");
		tlabel:SetBackground("HabnaPlugins/HugeBag/Resources/label_over.tga");
	end

	leftBar.MouseLeave=function(sender,args)
		tt:SetBackground("HabnaPlugins/HugeBag/Resources/tab_top.tga");
		tb:SetBackground("HabnaPlugins/HugeBag/Resources/tab_bottom.tga");
		tm:SetBackground("HabnaPlugins/HugeBag/Resources/tab_mid.tga");
		tlabel:SetBackground("HabnaPlugins/HugeBag/Resources/label.tga");
	end

	leftBar.MouseClick=function(sender,args)
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			self:SetWantsUpdates(true);
		end
	end

	topLeftCorner.MouseClick=function(sender,args)
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			self:SetWantsUpdates(true);
		elseif ( args.Button == Turbine.UI.MouseButton.Right ) then
			self.menu:ShowMenu()
		end
	end
	
	-- **^
	--**v HugeBag event handlers v**
	self.Update=function(sender,args)
		tscreenWidth, tscreenHeight = Turbine.UI.Display.GetSize()
		
		if ( tscreenWidth ~= screenWidth ) then
			if backpackSize == 45 then
				self:SetTop( tscreenHeight - WWinHeight + 69 - 75 );
			else
				self:SetTop( tscreenHeight - WWinHeight - 75 );
			end
			
			if ( windowOpen ) then
				self:SetLeft( tscreenWidth - ( winRate * 15 ) + 2 );
			else
				self:SetLeft( tscreenWidth - 28 );
			end
		screenWidth = tscreenWidth;
		end
		
		if ( windowOpen ) then
			if ( self:GetLeft() == ( screenWidth - 28 ) ) then
				self:SetLeft( self:GetLeft() )
				self:SetWantsUpdates( false );
				windowOpen = false;
			else
				self:SetLeft( self:GetLeft() + winRate )
			end
		else
			if ( self:GetLeft() == ( screenWidth - ( winRate * 15 ) + 2 ) ) then
				self:SetLeft( self:GetLeft() )
				self:SetWantsUpdates( false );
				windowOpen = true;
			else
				self:SetLeft( self:GetLeft() - winRate )
			end
		end
	end
	
	self.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			if ( HideWEsc ) then
				if ( windowOpen ) then
					self:SetVisible( true ); -- **v Hide HugeBag if ESC key is press v**
					self:SetWantsUpdates(true);
				end
			else
				self:SetVisible( true ); -- **v DO NOT Hide HugeBag if ESC key is press v**
			end
		end
		
		if ( args.Action == Turbine.UI.Lotro.Action.ToggleBags or
		     args.Action == Turbine.UI.Lotro.Action.ToggleBag1 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag2 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag3 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag4 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag5 )
		then			
			self:SetWantsUpdates(true);
		end
	end

	self.DragDrop = function( sender, args )
		local shortcut = args.DragDropInfo:GetShortcut();
		local destinationItemControl = itemListBox:GetItemAt( args.X - WInitXPos, args.Y - WInitYPos );
		
		if ( destinationItemControl ~= nil ) then -- ** if nil, then it's out of range, so don't do anything **
			local destinationIndex = itemListBox:IndexOfItem( destinationItemControl );
			self.backpack:PerformShortcutDrop(shortcut, destinationIndex, Turbine.UI.Control.IsShiftKeyDown() );
		end
	end
	--**^ HugeBag event handlers ^**
	-- **v backpack event handlers v**
	self.backpack.ItemAdded = function( sender, args )
		items[args.Index]:SetItem( self.backpack:GetItem( args.Index ) );
		freeslots = freeslots -1;
		self:PrintTitle()
	end
	
	self.backpack.ItemRemoved = function( sender, args )
		items[args.Index]:SetItem( self.backpack:GetItem( args.Index ) );
		freeslots = freeslots +1;
		self:PrintTitle()
	end
	
	self.backpack.ItemMoved = function( sender, args )
		items[args.OldIndex]:SetItem( self.backpack:GetItem( args.OldIndex ) );
		items[args.NewIndex]:SetItem( self.backpack:GetItem( args.NewIndex ) );
	end
	--**^ backpack event handlers ^**
	--^ EVENT HANDLERS SECTION ^--
end
-- **^

--v FUNCTIONS/METHODS SECTION v--
-- **v Refresh the backpack list v**
function frmMain:SetBackPack()
	items = nil;
	itemListBox:ClearItems();

	items = {}; --> ** Initialize the container that holds the elements referencing the player's inventory **
	--backpackSize = self.backpack:GetSize();
	
	local temp;
	local tName;

	for i = 1, backpackSize, 1 do
		if ( items[i] ) then
			items[i]:SetParent( nil );
		end
		
		-- Get item and set background color
		--self.items[i] = Turbine.UI.Lotro.ItemControl( self.backpack:GetItem( i ) );
		temp = Turbine.UI.Lotro.ItemControl( self.backpack:GetItem( i ) );
		temp:SetBackground( "HabnaPlugins/HugeBag/Resources/slotBackground.tga" );
		--temp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		items[i] = temp;
		items[i].id = i; -- For sorting purpose

		itemListBox:AddItem( items[i] );
	end
	
	self:CountFreeSlots()
end
-- **^
-- **v Count the free slots v**
function frmMain:CountFreeSlots()
	freeslots = 0;

	for i = 1, backpackSize, 1 do
		if ( self.backpack:GetItem( i ) == nil ) then
			freeslots = freeslots + 1;
		end
	end

	self:PrintTitle()
end
-- **^
-- **v Print the title with the free slots and the max v**
function frmMain:PrintTitle()
	local usedslots = backpackSize - freeslots;
	self:SetText( "free slots: " .. freeslots .. "  used slots: " .. usedslots .. "  max slots: " .. backpackSize );
end
-- **^
--^ FUNCTIONS/METHODS SECTION ^--