-- frmUtility.lua
-- written by Habna

--v IMPORT SECTION v--

--^ IMPORT SECTION ^--
--v GLOBAL VARIABLE SECTION v--
WinLocX, WinLocY = self, self;
frmUtility = Turbine.UI.Lotro.Window;
--^ GLOBAL VARIABLE SECTION ^--

function frmUtility()
	self = Turbine.UI.Lotro.Window()

	LoadSettings();

	-- **v Set backcolor, position, size and text of the window v**
	self:SetSize( 135, 80 );
	self:SetPosition( WinLocX, WinLocY );
	self:SetZOrder(1)
	self:SetText( "      Utility" );
	self:SetVisible( true );
	-- **^
	-- **v To create a new button v**
	local buttonReload = Turbine.UI.Lotro.Button();
	buttonReload:SetParent( self );
	buttonReload:SetPosition( 10, 35 );
	--buttonReload:SetSize( 75, 150 );
	buttonReload:SetWidth( 70 );
	buttonReload:SetText( "Reload" );
	buttonReload:SetVisible( true );

	local buttonUnload = Turbine.UI.Lotro.Button();
	buttonUnload:SetParent( self );
	buttonUnload:SetPosition( 10, 60 );
	--buttonUnload:SetSize( 75, 150 );
	buttonUnload:SetWidth( 70 );
	buttonUnload:SetText( "Unload" );
	buttonUnload:SetVisible( true );
	
	local buttonLoad = Turbine.UI.Lotro.Button();
	buttonLoad:SetParent( self );
	buttonLoad:SetPosition( 85, 35 );
	--buttonLoad:SetSize( 75, 150 );
	buttonLoad:SetWidth( 50 );
	buttonLoad:SetText( "Load" );
	buttonLoad:SetVisible( true );

	local buttonHelp = Turbine.UI.Lotro.Button();
	buttonHelp:SetParent( self );
	buttonHelp:SetPosition( 85, 60 );
	--buttonHelp:SetSize( 75, 150 );
	buttonHelp:SetWidth( 50 );
	buttonHelp:SetText( "Help" );
	buttonHelp:SetVisible( true );
	-- **^
	--**v Window event handlers v**
	self.PositionChanged = function( args )
		WinLocX, WinLocY = self:GetPosition();
		SaveSettings();
	end
	--**^ Window event handlers ^**
	--**v Button event handlers v**
	buttonUnload.Click = function(sender, args)
		UnloadHugeBag()
	end

	buttonReload.Click = function(sender, args)
		ReloadHugeBag()
	end

	buttonLoad.Click = function(sender, args)
		LoadHugeBag()
	end

	buttonHelp.Click = function(sender, args)
		ShowHelp()
	end
	--**^ Button event handlers ^**
	--^ EVENT HANDLERS SECTION ^--
end
-- **^
--v FUNCTIONS/METHODS SECTION v--
function UnloadHugeBag()
	Turbine.PluginManager.UnloadScriptState( "HugeBag" );
	write( "HugeBag Utility: HugeBag was unloaded" );
end

function ReloadHugeBag()
	write( "HugeBag Utility: Reloading HugeBag..." );
	Turbine.PluginManager.UnloadScriptState( "HugeBag" )
	Turbine.PluginManager.LoadPlugin("HugeBag")
	write( "HugeBag Utility: HugeBag was reloaded" );
end

function LoadHugeBag()
	Turbine.PluginManager.LoadPlugin("HugeBag")
	write( "HugeBag Utility: HugeBag was loaded" );
end

function ShowHelp()
	write( "*********************" );
	write( "**** HugeBag Utility ****" );
	write( "*********************" );
	write( "/hugebagu reload: Reload HugeBag" );
	write( "/hugebagu unload: Unload HugeBag" );
	write( "/hugebagu load: Load HugeBag" );
	write( "/hugebagu help/?: Show help commands" );
end

function LoadSettings( sender )
	settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagUtilitySettings" );
	
	-- **v no setting found, so save it v**
	if settings == nil then
		WinLocX = 650;
		WinLocY = 949;
		SaveSettings()
	end
	-- **^
	
	WinLocX = settings.X;
	WinLocY = settings.Y;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagUtilitySettings", Updatedsettings );
end

function SaveSettings()
	settings = {};
	settings.X = WinLocX;
	settings.Y = WinLocY;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagUtilitySettings", settings );
end
--^ FUNCTIONS/METHODS SECTION ^--